"use strict";
function isPromise(value) {
    return value && typeof value.then === 'function';
}
var MaybePromise = (function () {
    function MaybePromise(state) {
        this.state = state;
    }
    MaybePromise.prototype.chain = function (next) {
        if (isPromise(this.state)) {
            var promise = this.state.then(next);
            return new MaybePromise(promise);
        }
        else {
            var value = next(this.state);
            return new MaybePromise(value);
        }
    };
    MaybePromise.prototype.value = function () {
        return this.state;
    };
    return MaybePromise;
}());
exports.MaybePromise = MaybePromise;
